import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Graphics;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

public class $class_name$ extends MIDlet implements CommandListener {

	private GameEngine engine;
	private Display    display;
	private MyViewA	   viewA;
	private MyViewB	   viewB;
	private Command	   exit;
	private Command	   pause;
	private Command	   resume;
	
	public $class_name$() {
		this.display = Display.getDisplay(this);
		
		MyModel model = new MyModel($object-x$, $object-y$, $object-w$, $object-h$, $object-speed$);
		this.viewA = new MyViewA(model, $object-color1$);
		this.viewB = new MyViewB(model, $object-color2$);
		this.engine = new GameEngine(model, $game-fps$);
		
		Displayable drawingArea = this.engine.getDrawingArea(); 
			
		drawingArea.setCommandListener(this);
		this.engine.attach(viewA);
		this.engine.attach(viewB);
		
		this.resume = new Command("Resume", Command.SCREEN, 2);
		drawingArea.addCommand(this.resume);

		this.pause = new Command("Pause", Command.SCREEN, 1);
		drawingArea.addCommand(this.pause);
		
		this.exit = new Command("Exit", Command.EXIT, 1);
		drawingArea.addCommand(this.exit);
	}
	
	/* (non-Javadoc)
	 * @see javax.microedition.midlet.MIDlet#startApp()
	 */
	protected void startApp() throws MIDletStateChangeException {
		this.display.setCurrent(this.engine.getDrawingArea());
		this.engine.start();
	}
	
	/* (non-Javadoc)
	 * @see javax.microedition.lcdui.CommandListener#commandAction(javax.microedition.lcdui.Command, javax.microedition.lcdui.Displayable)
	 */
	public void commandAction(Command c, Displayable d) {
		if (c == this.exit) {
			this.notifyDestroyed();
		} else
		if (c == this.resume) {
			this.engine.resume();
		} else
		if (c == this.pause) {
			this.engine.pause();
		}
	}
	
	/* (non-Javadoc)
	 * @see javax.microedition.midlet.MIDlet#destroyApp(boolean)
	 */
	protected void destroyApp(boolean arg0) throws MIDletStateChangeException {}

	/* (non-Javadoc)
	 * @see javax.microedition.midlet.MIDlet#pauseApp()
	 */
	protected void pauseApp() {}
	
	private class MyViewA implements GameView {

		private MyModel model;
		private int 	color;
		
		public MyViewA(MyModel model, int color) {
			this.model = model;
			this.color = color;
		}
		
		public void render(Graphics g) {
			g.setColor(this.color);
			g.drawRect(this.model.x, this.model.y, this.model.w, this.model.h);
		}
	}
	
	private class MyViewB implements GameView {

		private MyModel model;
		private int 	color;
		
		public MyViewB(MyModel model, int color) {
			this.model = model;
			this.color = color;
		}
		
		public void render(Graphics g) {
			g.setColor(this.color);
			g.fillArc(this.model.x, this.model.y, this.model.w, this.model.h, 0, 360);
		}
	}
	
	private class MyModel implements GameModel {

		private int xd, yd;
		private int speed;
		
		int x, y;
		int w, h;
		
		public MyModel(int x, int y, int w, int h, int speed) {
			this.x = x;
			this.y = y;
			this.w = w;
			this.h = h;
			
			this.xd = this.yd = 1;
			this.speed = speed;
		}
		
		public void Ai(int keys, int width, int height) {
			if (this.x <= 0x00 || this.x + this.w >= width) {
				this.xd *= -1;
			}
			
			if (this.y <= 0x00 || this.y + this.h >= height) {
				this.yd *= -1;
			}
			
			this.x += speed * this.xd;
			this.y += speed * this.yd;
		}
	}
}
